## ros-noetic-xacro 1.14.14

=== debian/changelog ===
ros-noetic-xacro (1.14.14-1buster) buster; urgency=high

  * Dotted YAML access from list iterator (#318 <https://github.com/ros/xacro/issues/318>)
  * Link to extended wiki <https://github.com/ros/xacro/wiki>
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Thu, 20 Oct 2022 22:00:00 -0000

ros-noetic-xacro (1.14.13-1buster) buster; urgency=high

  * Only optionally activate comment evaluation (#310 <https://github.com/ros/xacro/issues/310>)Comment evaluation can be enabled with a special comment:
    
      * ``<!-- xacro:eval-comments -->`` or
      * ``<!-- xacro:eval-comments:on -->``
    It remains active for the following comments until:
    
      * the current XML tag's scope is left (or a new tag entered)
      * another tag or non-whitespace text is processed
      * it becomes explicitly disabled via: ``<!-- xacro:eval-comments:off -->``
    
  * Fix property resolution with namespace usage (#308 <https://github.com/ros/xacro/issues/308>)
    
      * Allow access to properties in parent scopes again (fixes #305 <https://github.com/ros/xacro/issues/305#issuecomment-1016811150>)
      * Pick correct scope when defining a property into the parent (fixes #307 <https://github.com/ros/xacro/issues/307>)Setting a property within the parent scope may occur in two contexts:From within a macro. In that case, one wants to set the property in the caller's scope.
        
        From within the included file. In that case, one wants to set the property in the includer's scope.
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 11 Feb 2022 23:00:00 -0000

ros-noetic-xacro (1.14.12-1buster) buster; urgency=high

  * Issue a warning only for evaluation errors in comments
  * Add LICENSE file
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 29 Jan 2022 23:00:00 -0000

ros-noetic-xacro (1.14.11-1buster) buster; urgency=high

  * Fix resolving of macros and properties declared and used in/from a namespace (#297 <https://github.com/ros/xacro/issues/297>, #306 <https://github.com/ros/xacro/issues/306>)Macros and properties that are declared within a namespaced include shouldn't require the namespace prefix when used within the namespace.
  * Perform expression evaluation in comments (#300 <https://github.com/ros/xacro/issues/300>)
  * Expose ``xacro.arg()`` to facilitate access to substitution args
  * Fix scoped macro evaluation
    
      * Replace ``[Macro|Property]NameSpace`` with common ``NameSpace`` class derived from ``Table``
      * Use the scoped macro Table
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 19 Jan 2022 23:00:00 -0000

ros-noetic-xacro (1.14.10-1buster) buster; urgency=high

  * Allow property names to be evaluated from an expression
    This allows to turn macros into a function that can compute an arbitrary property:
    
        <xacro:macro name="square" params="name args">
      <!-- Perform some complex computation and set the property within the parent's scope -->
      <xacro:property name="${name}" value="${[float(x)**2 for x in args]}" scope="parent" />
    </xacro:macro>
    <xacro:square name="result" args="${python.range(5)}" />
    
  * Fix error reporting for invalid symbols in NameSpaces
  * Allow removal of a property definition (#288 <https://github.com/ros/xacro/issues/288>)<xacro:property name="prop" remove="true"/>
  * Allow greedy property evaluation (#284 <https://github.com/ros/xacro/issues/284>)
    This can be used, to redefine a property from its previous value, e.g. for normalization:
    
        <xacro:property name="prop" value="${prop.lower()}" lazy_eval="false"/>
    
  * Correctly expose XML namespaces imported via ``xacro:include`` within a macro (#287 <https://github.com/ros/xacro/issues/287>)
  * Throw when attempting to declare a property starting with *double* underscore (#286 <https://github.com/ros/xacro/issues/286>)
  * Improve global symbols (#283 <https://github.com/ros/xacro/issues/283>)
    
      * Expose most builtin symbols of python
      * Expose xacro functions into ``xacro`` namespace
        
          * ``xacro.print_location()`` to print the current filestack
          * ``tokenize(string, sep=',; ', skip_empty=True)`` to facilitate string tokenization
          * ``message()``, ``warning()``, ``error()``, and ``fatal()`` to output messages on ``stderr``.
            All but ``message()`` print the error location (macro call and file hierarchy) by default:
            
                ${xacro.message('message', 'text', 2, 3.14, color=32, print_location=True)}
            ${xacro.warning('warning')}
            ${xacro.error('error', print_location=False)}
            ${xacro.fatal('fatal')}
            
        
      * Rework handling of file and macro stack, such that print_location() works from anywhere
      * Unit tests: Reduce reported ``stdout``/``stderr`` output
      * Rework definition of ``global_symbols`` to expose functions into namespaces python, math, xacro
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 01 Oct 2021 22:00:00 -0000

ros-noetic-xacro (1.14.9-1buster) buster; urgency=high

  * Allow more builtin symbols: sorted, set
  * Don't import hidden symbols from math package
  * Fix ``eval()`` security vulnerability
    
      * ``safe_eval()``: Forbid symbol names starting with *double* underscore
      * unit tests validating the protection mechanism
    
  * Generalize yaml ``!degrees`` constructor: Enable expressions as well
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Thu, 02 Sep 2021 22:00:00 -0000

ros-noetic-xacro (1.14.8-1buster) buster; urgency=high

  * Improve macro arg parsing (#278 <https://github.com/ros/xacro/issues/278>) to support:
    
      * ``$(substitution args)``


## ros-noetic-xacro 1.14.16

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(xacro)

find_package(catkin REQUIRED COMPONENTS roslint)

catkin_package(
  CFG_EXTRAS xacro-extras.cmake
)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
catkin_python_setup()

catkin_install_python(PROGRAMS scripts/xacro
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

if(CATKIN_ENABLE_TESTING)
  ## Add folders to be run by python nosetests
  catkin_add_nosetests(test)
  ## add tests for xacro's cmake functions
  add_subdirectory(test)
endif()

roslint_python()

=== test/test-xacro-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(xacro-test)

find_package(catkin REQUIRED COMPONENTS xacro)

catkin_package()

## manual usage of eval
xacro_add_xacro_file(../include1.xml manual1.xml)
list(APPEND xacro_outputs ${XACRO_OUTPUT_FILE})

xacro_add_xacro_file(../include2.xml manual2.xml OUTPUT MY_OUTPUT_VAR)
list(APPEND xacro_outputs ${MY_OUTPUT_VAR})

add_custom_target(xacro_target ALL DEPENDS ${xacro_outputs})
xacro_install(xacro_target ${xacro_outputs} DESTINATION xml)

## convenience function
xacro_add_files(TARGET xacro test.xacro REMAP bar:=foo foo:=bar INSTALL)

=== debian/changelog ===
ros-noetic-xacro (1.14.16-1focal) focal; urgency=high

  * Fix hasattr support of YamlDictWrapper (#324 <https://github.com/ros/xacro/issues/324>)
  * Contributors: Alec Tiefenthal, Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Tue, 23 May 2023 22:00:00 -0000

ros-noetic-xacro (1.14.15-1focal) focal; urgency=high

  * Evaluate ``arg`` value as str/unicode (#322 <https://github.com/ros/xacro/issues/322>)
  * Remove obsolete options from completion
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sun, 26 Feb 2023 23:00:00 -0000

ros-noetic-xacro (1.14.14-1focal) focal; urgency=high

  * Dotted YAML access from list iterator (#318 <https://github.com/ros/xacro/issues/318>)
  * Link to extended wiki <https://github.com/ros/xacro/wiki>
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Thu, 20 Oct 2022 22:00:00 -0000

ros-noetic-xacro (1.14.13-1focal) focal; urgency=high

  * Only optionally activate comment evaluation (#310 <https://github.com/ros/xacro/issues/310>)Comment evaluation can be enabled with a special comment:
    
      * ``<!-- xacro:eval-comments -->`` or
      * ``<!-- xacro:eval-comments:on -->``
    It remains active for the following comments until:
    
      * the current XML tag's scope is left (or a new tag entered)
      * another tag or non-whitespace text is processed
      * it becomes explicitly disabled via: ``<!-- xacro:eval-comments:off -->``
    
  * Fix property resolution with namespace usage (#308 <https://github.com/ros/xacro/issues/308>)
    
      * Allow access to properties in parent scopes again (fixes #305 <https://github.com/ros/xacro/issues/305#issuecomment-1016811150>)
      * Pick correct scope when defining a property into the parent (fixes #307 <https://github.com/ros/xacro/issues/307>)Setting a property within the parent scope may occur in two contexts:From within a macro. In that case, one wants to set the property in the caller's scope.
        
        From within the included file. In that case, one wants to set the property in the includer's scope.
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 11 Feb 2022 23:00:00 -0000

ros-noetic-xacro (1.14.12-1focal) focal; urgency=high

  * Issue a warning only for evaluation errors in comments
  * Add LICENSE file
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 29 Jan 2022 23:00:00 -0000

ros-noetic-xacro (1.14.11-1focal) focal; urgency=high

  * Fix resolving of macros and properties declared and used in/from a namespace (#297 <https://github.com/ros/xacro/issues/297>, #306 <https://github.com/ros/xacro/issues/306>)Macros and properties that are declared within a namespaced include shouldn't require the namespace prefix when used within the namespace.
  * Perform expression evaluation in comments (#300 <https://github.com/ros/xacro/issues/300>)
  * Expose ``xacro.arg()`` to facilitate access to substitution args
  * Fix scoped macro evaluation
    
      * Replace ``[Macro|Property]NameSpace`` with common ``NameSpace`` class derived from ``Table``
      * Use the scoped macro Table
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 19 Jan 2022 23:00:00 -0000

ros-noetic-xacro (1.14.10-1focal) focal; urgency=high

  * Allow property names to be evaluated from an expression
    This allows to turn macros into a function that can compute an arbitrary property:
    
        <xacro:macro name="square" params="name args">
      <!-- Perform some complex computation and set the property within the parent's scope -->
      <xacro:property name="${name}" value="${[float(x)**2 for x in args]}" scope="parent" />
    </xacro:macro>
    <xacro:square name="result" args="${python.range(5)}" />
    
  * Fix error reporting for invalid symbols in NameSpaces
  * Allow removal of a property definition (#288 <https://github.com/ros/xacro/issues/288>)<xacro:property name="prop" remove="true"/>
  * Allow greedy property evaluation (#284 <https://github.com/ros/xacro/issues/284>)
    This can be used, to redefine a property from its previous value, e.g. for normalization:
    
        <xacro:property name="prop" value="${prop.lower()}" lazy_eval="false"/>
    
  * Correctly expose XML namespaces imported via ``xacro:include`` within a macro (#287 <https://github.com/ros/xacro/issues/287>)
  * Throw when attempting to declare a property starting with *double* underscore (#286 <https://github.com/ros/xacro/issues/286>)
  * Improve global symbols (#283 <https://github.com/ros/xacro/issues/283>)
    
      * Expose most builtin symbols of python
      * Expose xacro functions into ``xacro`` namespace
        
          * ``xacro.print_location()`` to print the current filestack
          * ``tokenize(string, sep=',; ', skip_empty=True)`` to facilitate string tokenization
          * ``message()``, ``warning()``, ``error()``, and ``fatal()`` to output messages on ``stderr``.
            All but ``message()`` print the error location (macro call and file hierarchy) by default:
            
                ${xacro.message('message', 'text', 2, 3.14, color=32, print_location=True)}
            ${xacro.warning('warning')}
            ${xacro.error('error', print_location=False)}
            ${xacro.fatal('fatal')}
            
        
      * Rework handling of file and macro stack, such that print_location() works from anywhere
      * Unit tests: Reduce reported ``stdout``/``stderr`` output
      * Rework definition of ``global_symbols`` to expose functions into namespaces python, math, xacro
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 01 Oct 2021 22:00:00 -0000

ros-noetic-xacro (1.14.9-1focal) focal; urgency=high

  * Allow more builtin symbols: sorted, set
  * Don't import hidden symbols from math package


=== debian/control ===
Source: ros-noetic-xacro
Section: misc
Priority: optional
Maintainer: Robert Haschke <rhaschke@techfak.uni-bielefeld.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin (>= 0.5.68), ros-noetic-roslint, ros-noetic-rostest <!nocheck>
Homepage: http://ros.org/wiki/xacro
Standards-Version: 3.9.2

Package: ros-noetic-xacro
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-roslaunch
Description: Xacro (XML Macros) Xacro is an XML macro language.
 With xacro, you can construct shorter and more readable XML files by using macros that expand to larger XML expressions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-xacro//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
